#!/usr/bin/env python

usage =  """
Usar: dv2divx.py [--audio=<audio>] <origen> <destino>

  ej: dv2divx.py blah1.dv blah1_final.avi
      dv2divx.py --audio=fondo.mp3 blah1.dv blah1_final.avi
"""

import sys, os

def main(orig, dest, audio):
    if audio is None:
        cmdaudio = "-oac mp3lame -lameopts vol=2:preset=128"
    else:
        cmdaudio = '-oac copy -audiofile "%s"' % audio

    # 437:240
    orden = 'mencoder "%s" -ni -forceidx -vf scale=480:360 %s -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=800:vpass=1:turbo -o "%s"' % (orig, cmdaudio, dest)
    print orden
    if os.system(orden):
        print "Problemas! Saliendo..."
        sys.exit()

    orden = 'mencoder "%s" -ni -forceidx -vf scale=480:360 %s -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=800:vpass=2:vme=4:dia=2:mbd=1:v4mv:lumi_mask=0.3:dark_mask=0.3:ilme:last_pred=50:nr=500 -o "%s"'  % (orig, cmdaudio, dest)
    print orden
    if os.system(orden):
        print "Problemas! Saliendo..."
        sys.exit()

    os.remove("divx2pass.log")
    return


if __name__ == "__main__":
    if len(sys.argv) == 4:
        if sys.argv[1].startswith("--audio="):
            audio = sys.argv[1].split("=", 1)[1]
        else:
            print usage
            sys.exit(2)
        origen = sys.argv[2]
        destin = sys.argv[3]
    elif len(sys.argv) == 3:
        audio = None
        origen = sys.argv[1]
        destin = sys.argv[2]
    else:
        print usage
        sys.exit(2)

    if not os.access(origen, os.R_OK):
        print "No se puede acceder al archivo origen"
        sys.exit()

    main(origen, destin, audio)
